[HAOI2007]理想的正方形

题目描述

有一个 \(a \times b\) 的整数组成的矩阵,现请你从中找出一个 \(n \times n\) 的正方形区域,使得该区域所有数中的最大值和最小值的差最小。

输入格式

第一行为 \(3\) 个整数,分别表示 \(a,b,n\) 的值。

第二行至第 \(a+1\) 行每行为 \(b\) 个非负整数,表示矩阵中相应位置上的数。每行相邻两数之间用一空格分隔。

输出格式

仅一个整数,为 \(a \times b\) 矩阵中所有“ \(n \times n\) 正方形区域中的最大整数和最小整数的差值”的最小值。

样例 #1

样例输入 #1

5 4 2
1 2 5 6
0 17 16 0
16 17 2 1
2 10 2 1
1 2 2 2

样例输出 #1

1

提示

问题规模。

矩阵中的所有数都不超过 \(1,000,000,000\)。

\(20\%\) 的数据 \(2 \le a,b \le 100,n \le a,n \le b,n \le 10\)。

\(100\%\) 的数据 \(2 \le a,b \le 1000,n \le a,n \le b,n \le 100\)。

题解

前置知识

试想一下,如果我们把\(a*b\)的矩阵改为长度为\(a\)的序列,要找的东西变成长度为\(n\)的子段,那不就变成单调队列之滑动窗口了嘛。

可以先看看我写的这篇关于滑动窗口的博客。

有了这些对单调队列的基本认知,我们不难想出一种本题的做法。

方法分析

首先可以将\(a*b\)的矩阵理解为\(b\)行长度为\(a\)的序列,然后对每一行的序列使用“滑动窗口”,这样就可以处理出每一行中长度为\(n\)的子段中所有数的最大值和最小值。

我们用\(board[i][j]\)来存原来的矩阵,用\(x1[i][j]\)和\(x2[i][j]\)分别记录第\(i\)行第\(j\)个窗口的最小值和最大值。那么我们每一行就能产生\(b-n+1\)个窗口。处理出来的\(x1\)和\(x2\)规模就是\(a*(b-n+1)\).

for(int i=1;i<=a;i++)
{
int h=0,t=0;
memset(q1,0,sizeof(q1));
memset(q2,0,sizeof(q2));
for(int j=1;j<=b;j++)
{
while(h<=t&&j-q1[h]>=n) h++;
while(h<=t&&board[i][j]<board[i][q1[t]]) t--;
q1[++t]=j;
if(j>=n) x1[i][j-n+1]=board[i][q1[h]];
}
for(int j=1;j<=b;j++)
{
while(h<=t&&j-q2[h]>=n) h++;
while(h<=t&&board[i][j]>board[i][q2[t]]) t--;
q2[++t]=j;
if(j>=n) x2[i][j-n+1]=board[i][q2[h]];
}
}

然后我们在处理好的\(x1\)和\(x2\)基础上,对每一列使用“滑动窗口”。如果说每一行的滑动窗口是从左往右滑动的,那么每一列的滑动窗口就是从上往下滑动的。

我们用用\(y1[i][j]\)和\(y2[i][j]\)分别记录第\(i\)列第\(j\)个窗口的最小值和最大值。那么我们每一列就能产生\(a-n+1\)个窗口。处理出来的\(y1\)和\(y2\)规模就是\((a-n+1)*(b-n+1)\).

for(int i=1;i<=b-n+1;i++)
{
int h=0,t=0;
memset(q1,0,sizeof(q1));
memset(q2,0,sizeof(q2));
for(int j=1;j<=a;j++)
{
while(h<=t&&j-q1[h]>=n) h++;
while(h<=t&&x1[j][i]<x1[q1[t]][i]) t--;
q1[++t]=j;
if(j>=n) y1[j-n+1][i]=x1[q1[h]][i];
}
for(int j=1;j<=a;j++)
{
while(h<=t&&j-q2[h]>=n) h++;
while(h<=t&&x2[j][i]>x2[q2[t]][i]) t--;
q2[++t]=j;
if(j>=n) y2[j-n+1][i]=x2[q2[h]][i];
}
}

回想一下,\(x\)数组处理出的是每一行长度为\(n\)的子段中最小/最大值,\(y\)数组处理出的是\(x\)的基础上每一列长度为\(n\)的子段中最小/最大值,那么这样一来\(y\)数组中就是整个矩阵中\(n*n\)的正方形区域中的最小/最大值。

然后只需要遍历一遍,求出最小的\(y2[i][j]-y1[i][j]\)即可。

#include<iostream>
#include<cstring>
#include<cstdio>
#include<algorithm>
using namespace std;
const int N=1005;
int a,b,n;
int board[N][N];
int x1[N][N],x2[N][N],y1[N][N],y2[N][N];
int q1[N],q2[N];
int cntx1,cntx2,cnty1,cnty2;
int minn(int a,int b)
{
return a<b?a:b;
}
int ans=2147483647;
int main()
{
scanf("%d%d%d",&a,&b,&n);
for(int i=1;i<=a;i++)
for(int j=1;j<=b;j++)
scanf("%d",&board[i][j]);
for(int i=1;i<=a;i++)
{
int h=0,t=0;
memset(q1,0,sizeof(q1));
memset(q2,0,sizeof(q2));
for(int j=1;j<=b;j++)
{
while(h<=t&&j-q1[h]>=n) h++;
while(h<=t&&board[i][j]<board[i][q1[t]]) t--;
q1[++t]=j;
if(j>=n) x1[i][j-n+1]=board[i][q1[h]];
}
for(int j=1;j<=b;j++)
{
while(h<=t&&j-q2[h]>=n) h++;
while(h<=t&&board[i][j]>board[i][q2[t]]) t--;
q2[++t]=j;
if(j>=n) x2[i][j-n+1]=board[i][q2[h]];
}
}
memset(q1,0,sizeof(q1));
memset(q2,0,sizeof(q2));
for(int i=1;i<=b-n+1;i++)
{
int h=0,t=0;
memset(q1,0,sizeof(q1));
memset(q2,0,sizeof(q2));
for(int j=1;j<=a;j++)
{
while(h<=t&&j-q1[h]>=n) h++;
while(h<=t&&x1[j][i]<x1[q1[t]][i]) t--;
q1[++t]=j;
if(j>=n) y1[j-n+1][i]=x1[q1[h]][i];
}
for(int j=1;j<=a;j++)
{
while(h<=t&&j-q2[h]>=n) h++;
while(h<=t&&x2[j][i]>x2[q2[t]][i]) t--;
q2[++t]=j;
if(j>=n) y2[j-n+1][i]=x2[q2[h]][i];
}
}
for(int i=1;i<=a-n+1;i++)
for(int j=1;j<=b-n+1;j++)
ans=minn(ans,y2[i][j]-y1[i][j]);
printf("%d\n",ans);
return 0;
}

P2216 [HAOI2007]理想的正方形 方法记录的更多相关文章

  1. 洛谷 P2216 [HAOI2007]理想的正方形

    P2216 [HAOI2007]理想的正方形 题目描述 有一个a*b的整数组成的矩阵,现请你从中找出一个n*n的正方形区域,使得该区域所有数中的最大值和最小值的差最小. 输入输出格式 输入格式: 第一 ...

  2. P2216 [HAOI2007]理想的正方形 (单调队列)

    题目链接:P2216 [HAOI2007]理想的正方形 题目描述 有一个 \(a\times b\)的整数组成的矩阵,现请你从中找出一个 \(n\times n\)的正方形区域,使得该区域所有数中的最 ...

  3. P2216 [HAOI2007]理想的正方形

    题目描述 有一个a*b的整数组成的矩阵,现请你从中找出一个n*n的正方形区域,使得该区域所有数中的最大值和最小值的差最小. 输入输出格式 输入格式: 第一行为3个整数,分别表示a,b,n的值 第二行至 ...

  4. 洛谷 P2216 [HAOI2007]理想的正方形 || 二维RMQ的单调队列

    题目 这个题的算法核心就是求出以i,j为左上角,边长为n的矩阵中最小值和最大值.最小和最大值的求法类似. 单调队列做法: 以最小值为例: q1[i][j]表示第i行上,从j列开始的n列的最小值.$q1 ...

  5. [P2216] [HAOI2007]理想的正方形 「单调队列」

    思路:用单调队列分别维护行与列. 具体实现方法:是先用单调队列对每一行的值维护,并将a[][]每个区间的最大值,最小值分别存在X[][]和x[][]中. 那么X[][]与x[][]所存储的分别是1×n ...

  6. 洛谷P2216 HAOI2007 理想的正方形 (单调队列)

    题目就是要求在n*m的矩形中找出一个k*k的正方形(理想正方形),使得这个正方形内最值之差最小(就是要维护最大值和最小值),显然我们可以用单调队列维护. 但是二维平面上单调队列怎么用? 我们先对行处理 ...

  7. 【DP】【单调队列】洛谷 P2216 [HAOI2007]理想的正方形 题解

        算是单调队列的复习吧,不是很难 题目描述 有一个$a\times b$的整数组成的矩阵,现请你从中找出一个$n\times n$的正方形区域,使得该区域所有数中的最大值和最小值的差最小. 输入 ...

  8. P2216 [HAOI2007]理想的正方形(二维RMQ)

    题目描述 有一个a*b的整数组成的矩阵,现请你从中找出一个n*n的正方形区域,使得该区域所有数中的最大值和最小值的差最小. 输入输出格式 输入格式: 第一行为3个整数,分别表示a,b,n的值 第二行至 ...

  9. 洛谷P2216: [HAOI2007]理想的正方形 单调队列优化DP

    洛谷P2216 )逼着自己写DP 题意: 给定一个带有数字的矩阵,找出一个大小为n*n的矩阵,这个矩阵中最大值减最小值最小. 思路: 先处理出每一行每个格子到前面n个格子中的最大值和最小值.然后对每一 ...

随机推荐

  1. C++ 实现可变参数的三个方法

    有时我们无法提前预知应该向函数传递几个实参.例如,我们想要编写代码输出程序产生的错误信息,此时最好用同一个函数实现该项功能,以便对所有错误的处理能够整齐划一.然而,错误信息的种类不同,所以调用错误输出 ...

  2. Nuget打包并上传教程

    一.准备 1 . 下载 Download NuGet.exe 2 . windows 系统下设置环境变量 path中 或者 在dos 命令窗口下cd转到 nuget.exe 所在目录,这里为了每次使用 ...

  3. 使用.NET简单实现一个Redis的高性能克隆版(四、五)

    译者注 该原文是Ayende Rahien大佬业余自己在使用C# 和 .NET构建一个简单.高性能兼容Redis协议的数据库的经历. 首先这个"Redis"是非常简单的实现,但是他 ...

  4. 【Java面试】什么是IO的多路复用机制?

    "什么是IO的多路复用机制?" 这是一道年薪50W的面试题,很遗憾,99%的人都回答不出来. 大家好,我是Mic,一个工作了14年的Java程序员. 今天,给大家分享一道网络IO的 ...

  5. 主流前沿的开源监控和报警系统Prometheus+Grafana入门之旅

    Prometheus概述 定义 Prometheus 官网地址 https://prometheus.io/ Prometheus 官网文档地址 https://prometheus.io/docs/ ...

  6. Luogu3594 [POI2015]WIL-Wilcze doły (双端队列)

    单调性显然,双端队列队列维护严格单调递减手写双端队列真的可恶. #include <iostream> #include <cstdio> #include <cstri ...

  7. zabbix 报表动作日志 报错”503“

  8. 我写的蓝宝石留言本php版 v4.5

    蓝宝石留言本php版v4.5采用原生php编写,在php5.6~php7.x下调试通过.本留言本使用了utf-8编码. include/config1.php是数据库连接参数的配置文件, includ ...

  9. Fiddler抓包工具下载安装及使用

    一.Fiddler简介 简介: Fiddler是一款强大的Web调试工具,他能记录所有客户端和服务器的HTTP/HTTPS请求 工作原理: Fiddler是以代理web服务器的形式工作的,它使用代理地 ...

  10. SpringBoot读取.yml配置文件最常见的两种方式-源码及其在nacos的应用

    一.前言 我们在开发中会经常遇到一些可能会变的值,比如数据库的密码,一些关键链接的配置等等. 都需要我们写在配置文件中,这样可以把这些配置文件放到nacos上进行管理,修改nacos的配置,咱们发布的 ...